blog/urls.py
from django.urls import path, re_path
from . import views
from django.conf.urls import url

from .models import Article, Subject

# For redirecting
from django.views.generic import RedirectView


app_name = 'blog'

urlpatterns = [
    
    path('home/', views.index, name='home'),
    path('subjects/', views.SubjectListView.as_view(), name='subjects'),
    path('subject/<slug:slug>/', views.SubjectDetailView.as_view(), name='subject-detail'),
    path('articles/', views.ArticleListView.as_view(), name='articles'),
    path('articles/<slug:slug>/', views.ArticleListBySlugView.as_view(), name='articles-by-subject-slug'),
    path('article/<slug:slug>/', views.ArticleDetailView.as_view(), name='article-detail'),
    path('article/<slug:slug>/post_comment',views.post_comment, name='post-comment'),
    url ('', views.index, name='index'),
]

mysite/urls.py
from django.contrib import admin
from django.urls import path, include, re_path

# For redirecting
from django.views.generic import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('blog/', include('blog.urls')),
]

# For static
from django.conf import settings
from django.conf.urls.static import static

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)


   # path('', RedirectView.as_view(url='catalog', permanent=True)),
    # path('polls/', include('polls.urls')),
    # path('admin/', admin.site.urls),
    # path('catalog/', include('catalog.urls')),
    # path('blog/',include('blog.urls'))

blog/models.py
from django.db import models
from django.urls import reverse
from django.template.defaultfilters import slugify

from tinymce.models import HTMLField


class Subject(models.Model):
    name = models.CharField(max_length=200, help_text="Enter a subject of article")
    annotation = models.CharField(max_length = 500, help_text = 'Enter brief introduction to subject', null = True)
    slug = models.SlugField(editable=False)
    parent_subject = models.ForeignKey('self',null=True, on_delete=models.CASCADE, blank= True)

    def save(self):
        if not self.slug:
            slug = slugify(self.name)
            i = 0
            while True:
                try:
                    subject = Subject.objects.get(slug=slug)
                    i += 1
                    if subject == self:
                        self.slug = slug
                        break
                    else:
                        slug = slug + '-'
                except:
                    if i == 0:
                        self.slug = slug
                    else:
                        self.slug = slug + str(i)
                    break

        super(Subject, self).save()


    class Meta:
        ordering = ['name']


    def articles_length(self):
        print('CHECKING')
        try:
            num = Article.objects.filter(subject=self.pk).count()
        except Article.DoesNotExist:
            return 0
        print(num)

        return num

    def recent_articles(self):
        try:
            articles = Article.objects.filter(subject=self.pk)[:4]
        except Article.DoesNotExist:
            return None
        return articles

    def __str__(self):
        return self.name


class Article(models.Model):
    title = models.CharField(max_length=200)
    summary = HTMLField()
    subject = models.ManyToManyField(Subject, help_text="Select a subject for this article")
    date_of_publish = models.DateField(null=True, blank=True)
    num_views = models.IntegerField(default=0)
    slug = models.SlugField(editable=False)
    brief_introduction = models.CharField(max_length = 200, null=True)


    class Meta:
        ordering = ['-date_of_publish','title']

    def increment_views(self):
        self.num_views += 1
        self.save()
        return ''

    def save(self):
        if not self.slug:
            slug = slugify(self.title)
            i = 0
            while True:
                try:
                    article = Article.objects.get(slug=slug)
                    i += 1
                    if article == self:
                        self.slug = slug
                        break
                    else:
                        slug = slug + '-'
                except:
                    if i == 0:
                        self.slug = slug
                    else:
                        self.slug = slug + str(i)
                    break

        super(Article, self).save()

    def __str__(self):
        return self.title

    def display_subject(self):
        return ', '.join([subject.name for subject in self.subject.all()[:3]])

    display_subject.short_description = 'Subject'

    def get_absolute_url(self):
        """
        Returns the url to access a particular article instance.
        """
        return reverse('article-detail', args=[str(self.id)])


class Comment(models.Model):
    article = models.ForeignKey(Article,on_delete=models.CASCADE) # What article it refers to
    author = models.CharField(max_length=200, help_text = 'Enter your name', blank=False)
    text = models.CharField(max_length=200, help_text = 'Enter the text of comment', blank=False)
    date_of_publish = models.DateTimeField(auto_now_add=True, blank=True)
    parent = models.ForeignKey(
        'self',
        on_delete=models.CASCADE,
        parent_link=True,
        related_name='children',
        null=True,
        blank=True)

    def __str__(self):
        return f"{self.author}: {self.text}"

blog/forms.py
from .models import Comment

from django.forms import ModelForm

class CommentForm(ModelForm):

    class Meta:
        model = Comment
        fields= (
                    'author', 
                    'text', 
                    'parent'
                )

blog/views.py
from django.shortcuts import render,get_object_or_404,get_list_or_404
from django.http import HttpResponse,Http404,JsonResponse

from .models import Article,Comment,Subject

from django.views.decorators.csrf import csrf_exempt


import json


# forms
from .forms import CommentForm

# For class-view components
from django.views import generic

def index(request):
    most_popular_articles = get_list_or_404(Article.objects.order_by('-num_views'))[:4]
    return render(request,'blog/home_page.html',{
        'most_popular_articles': most_popular_articles
    })


class SubjectListView(generic.ListView):
    model = Subject
    queryset = Subject.objects.filter(parent_subject=None)
    paginate_by = 10


class SubjectDetailView(generic.DetailView):
    model = Subject


class ArticleListView(generic.ListView):
    model = Article
    paginate_by = 1


class ArticleDetailView(generic.DetailView):
    model = Article


class ArticleListBySlugView(generic.ListView):
    
    paginate_by = 1
    template_name = 'blog/articles_by_subject_slug.html'
    context_object_name = 'article_list'

    def get_queryset(self):
        self.subject = get_object_or_404(Subject, slug=self.kwargs['slug'])
        return Article.objects.filter(subject=self.subject)


@csrf_exempt
def post_comment(request,slug):
    print('Got there finally')
    article = get_object_or_404(Article,slug = slug)

    if request.method == 'POST':
        
        body_unicode = request.body.decode('utf-8')
        body = json.loads(body_unicode)

        print(body)
        
        form = CommentForm(data=body)

        
        
        if form.is_valid():
            comment = form.save(commit = False)
            comment.article = article
            comment.save()
            return JsonResponse({
                'success': True,
                'pk': comment.pk,
                'date_of_publish': comment.date_of_publish.strftime("%Y-%m-%d %H:%M:%S"),
                'status_code':200
            })
        else:
            pass
            # print(form.cleaned_data)
            # print(form.data['author'])
    return JsonResponse({
        'success': False,
        'status_code':401
    })

blog/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    {% load static %}
  <title>{% block title %}Blog{% endblock %}</title>
  <link href="https://fonts.googleapis.com/css?family=Zilla+Slab&display=swap" rel="stylesheet">
  <link rel="shortcut icon" href="{% static 'favicon.ico' type='image/x-icon' %}">
  <link href='http://fonts.googleapis.com/css?family=Lato&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- Добавление дополнительного статического CSS файла -->
 
  <link rel="stylesheet" href="{% static 'css/styles.css' %}">


</head>

<body>

  <div class="container-wrapper">

    <div class="container">
            <div class="nav-block">

                    <div class="brand-name">
                        <span class="brand">
                            Computer Science Blog
                        </span>
                    </div>

                    <div id="menu-toggler-block">
                        <div class="bar1"></div>
                        <div class="bar2"></div>
                        <div class="bar3"></div>
                      </div>
                    
                    <div class="menu-nav menu-mobile-nav">
                        {% block navbar %}
                            
                            <ul class="menu-nav-list">
                                <li><a href="{% url 'blog:index' %}">Home</a></li>
                                <li><a href="{% url 'blog:subjects' %}">Subjects</a></li>
                                <li><a href="{% url 'blog:articles' %}">Articles</a></li>
                            </ul>
                        {% endblock %}
                    </div>
                        
            </div>

            <div class="main-block">
                {% block content %}{% endblock %}
                    
                {% block pagination %}
                    
                        <div class="pagination">
                                    {% if is_paginated %}
                                <div class="page-links">
                                    <div class="page-links-button-block">
                                        {% if page_obj.has_previous %}
                                            <a href="{{request.path}}?page={{page_obj.previous_page_number}}">
                                                <span class="page-button">
                                                        <
                                                </span>
                                            </a>
                                        {% endif %}
                                    </div>


                                    <span class="page-current">
                                            Page {{page_obj.number }} of {{ page_obj.paginator.num_pages }}
                                    </span>
                                    
                                    <div class="page-links-button-block">
                                            {% if page_obj.has_next %}
                                            <a href="{{request.path}}?page={{page_obj.next_page_number}}">
                                                    <span class="page-button">
                                                        >
                                                    </span>
                                            </a>
                                        {% endif %}
                                    </div>
                                    
                                    
                                    
                                </div>
                                {% endif %}
                            </div>
                    
                {% endblock %}
            </div>
    </div>

  </div>

  <script src="{% static 'js/script.js' %}"></script>
</body>
</html>

blog/templates/blog/article_detail.html
{% extends 'base.html' %}


{% block title %}
    {{article.title}}
    {{article.increment_views}}
{% endblock title %}




{% block content %}

    <div class="article-detail-container">

        <div class="article-detail-title-block">
            <h1>{{article.title}}</h1>
        </div>

        <div class="article-detail-subjects-block">
            
            {% for subject in article.subject.all %}
                
                <div class="article-detail-subject">
                    <a href=" {% url 'blog:subject-detail' subject.slug  %}">
                        <h4>{{subject.name}}</h4>
                    </a>
                </div>

            {% endfor %}

        </div>


        <div class="article-detail-content">
            {{article.summary|safe}}
        </div>

        <div class="article-detail-comments-block">

                <div class="article-comments-title">
                    <h1>Comments:</h1>
                </div>
            
                <div class="comment-layer-block comment-layer-block-first-layer">
                    {% for comment in article.comment_set.all %}
                        {% if not comment.parent %}     
                            {% include "blog/tree_comment.html" %}
                        {% endif %}
                    {% endfor %}
                </div> 
        </div>

        <div class="article-comment-form-block" id="comment_block">

            <h1 class="article-comment-form-title">Your comment</h1>

            <form action="" method="post">
                {% csrf_token %}
                <div class="comment-form-block">
                        <input type="hidden" name="article" value="{{article.pk}}" id='article' >
                        <input type="hidden" name="parent" value="none" id="parent">
                        <div class="author-error error_text"></div>
                        <input type="text" name="author" class="comment-form-author" placeholder="Your name">
                        <div class="comment-error error_text"></div>
                        <textarea name="text" cols="30" rows="10" class="comment-form-text" placeholder="Your comment"></textarea>
                        <input type="submit" value="Publish" class="comment-form-submit">
                </div>
            </form>
        
        </div>
        

    </div>

{% endblock content %}

blog/templates/blog/article_list.html
{% extends 'base.html' %}


{% block title %}
    Articles
{% endblock title %}



{% block content %}

        <!-- <div class="header-block">
           <h1> Recent articles </h1>
        </div> -->
        

        <div class="articles_block">


                {% if article_list %}

                    {% for article in article_list  %}
                        
                        <div class="article_block">


                            <a href="{% url 'blog:article-detail' article.slug %}">

                                    <div class="article_title_block">
                                            <h2>{{article.title}}</h2>
                                        </div>
            
                                        <div class="article_intro_block">
                                            
                                            {% if article.brief_introduction %}
                                                <p>{{article.brief_introduction}}</p>
                                            {% else %}
                                                <p>No brief introduction</p>
                                            {% endif %}
                                                
                                        </div>
            
                                        <div class="article_block_meta_info">
                                            <div class="article_block_date">
                                                <h5>{{article.date_of_publish}}</h5>
                                            </div>
                                            <div class="article_block_num_views">
                                                <h5>
                                                    {% if article.num_views == 0 %}
                                                        No views
                                                    {% else %}
                                                        {{article.num_views}} views
                                                    {% endif  %}
                                                    
                                                </h5>
                                            </div>
                                        </div>

                            </a>

                            
                        </div>

                    {% endfor %}
                        
                {% endif %}
                
        </div>

        

    </div>

{% endblock content %}

blog/templates/blog/articles_by_subject_slug.html
{% extends 'base.html' %}


{% block title %}
    Articles
{% endblock title %}



{% block content %}

        <!-- <div class="header-block">
           <h1> Recent articles </h1>
        </div> -->
        

        <div class="articles_block">


                {% if article_list %}

                    {% for article in article_list  %}
                        
                        <div class="article_block">


                            <a href="{% url 'blog:article-detail' article.slug %}">

                                    <div class="article_title_block">
                                            <h2>{{article.title}}</h2>
                                        </div>
            
                                        <div class="article_intro_block">
                                            
                                            {% if article.brief_introduction %}
                                                <p>{{article.brief_introduction}}</p>
                                            {% else %}
                                                <p>No brief introduction</p>
                                            {% endif %}
                                                
                                        </div>
            
                                        <div class="article_block_meta_info">
                                            <div class="article_block_date">
                                                <h5>{{article.date_of_publish}}</h5>
                                            </div>
                                            <div class="article_block_num_views">
                                                <h5>
                                                    {% if article.num_views == 0 %}
                                                        No views
                                                    {% else %}
                                                        {{article.num_views}} views
                                                    {% endif  %}
                                                    
                                                </h5>
                                            </div>
                                        </div>

                            </a>

                            
                        </div>

                    {% endfor %}
                        
                {% endif %}
                
        </div>

        

    </div>

{% endblock content %}

blog/templates/blog/home_page.html
{% extends 'base.html' %}


{% block title %}
    Home
{% endblock title %}


{% block content %}
    
<div class="subject-detail-container">

        <div class="subject-detail-description">
                <div class="subject-detail-name">
                    <h1 class='subject-detail-name-header'>
                        Computer Science Blog
                    </h1>
                </div>
                <div class="subject-detail-annotation">
                    <p class="subject-detail-annotation-text">
                        Discover new things!
                    </p>
                </div>
            </div>



        <div class="header-block">
            <h1>Most popular articles</h1>
        </div>
        

        <div class="articles_block">

                {% if most_popular_articles %}

                            
                    {% for article in most_popular_articles  %}
                        
                        <div class="article_block">

                            <a href="{% url 'blog:article-detail' article.slug %}">

                                <div class="article_title_block">
                                    <h2>{{article.title}}</h2>
                                </div>

                                <div class="article_intro_block">
                                    {% if article.brief_introduction %}
                                        <p>{{article.brief_introduction}}</p>
                                    {% else %}
                                        <p>No brief introduction</p>
                                    {% endif %}
                                </div>

                                <div class="article_block_meta_info">
                                    <div class="article_block_date">
                                        <h5>{{article.date_of_publish}}</h5>
                                    </div>
                                    <div class="article_block_num_views">
                                        <h5>
                                            {% if article.num_views == 0 %}
                                                No views
                                            {% else %}
                                                {{article.num_views}} views
                                            {% endif  %}
                                            
                                        </h5>
                                    </div>
                                </div>
                            </a>
                        </div>

                    {% endfor %}
                        
                {% endif %}
                
        </div>

        

    </div>


{% endblock content %}

blog/templates/blog/subject_detail.html
{% extends 'base.html' %}


{% block title %}
    {{subject.name}}
{% endblock title %}



{% block content %}

    <div class="subject-detail-container">

        <div class="subject-detail-description">
            <div class="subject-detail-name">
                <h1 class='subject-detail-name-header'>
                    {{subject.name}}
                </h1>
            </div>
            <div class="subject-detail-annotation">
                <p class="subject-detail-annotation-text">
                    {{subject.annotation}}
                </p>
            </div>
        </div>

        {% if subject.subject_set.all %}

            <div class="header-block">
                <h1> Related subjects </h1>
            </div>

            <div class="subject-related-subjects">
                    
            
                    {% for sub in subject.subject_set.all %}

                        <div class="subject_block">
        
                            <a href="{% url 'blog:subject-detail' sub.slug %}" class="subject_block_link">
        
                                    <div class="subject_block_title">
                                            <h2>
                                                    {{sub.name}}
                                            </h2>
                                    </div>
                                    
                                    <div class="subject_block_annotation">
                                            <p>
                                                {% if sub.annotation %}
                                                        {{sub.annotation}}
                                                {% else %}
                                                        No description
                                                {% endif %}
                                            </p>
                                        
                                    </div>
        
                            </a>
                            
                        </div>
    
                    {% endfor %}

                    
            
            </div>
        {% endif %}

        
        <div class="header-block">
            {% if subject.recent_articles %}
                <h1> Recent articles </h1>
            {% else %}
                <h1> There arent any articles on this subject yet </h1>
            {% endif %}
        </div>
        

        

        <div class="articles_block">

                {% if subject.recent_articles %}

                    
                
                    {% for article in subject.recent_articles  %}
                        
                        <div class="article_block">

                            <a href="{% url 'blog:article-detail' article.slug %}">

                                <div class="article_title_block">
                                    <h2>{{article.title}}</h2>
                                </div>

                                <div class="article_intro_block">
                                    {% if article.brief_introduction %}
                                        <p>{{article.brief_introduction}}</p>
                                    {% else %}
                                        <p>No brief introduction</p>
                                    {% endif %}
                                </div>

                                <div class="article_block_meta_info">
                                    <div class="article_block_date">
                                        <h5>{{article.date_of_publish}}</h5>
                                    </div>
                                    <div class="article_block_num_views">
                                        <h5>
                                            {% if article.num_views == 0 %}
                                                No views
                                            {% else %}
                                                {{article.num_views}} views
                                            {% endif  %}
                                            
                                        </h5>
                                    </div>
                                </div>
                            </a>
                        </div>

                    {% endfor %}

                    {% if subject.articles_length > 4 %}


                        <div class="article_block">

                                <a href="{% url 'articles-by-subject-slug' subject.slug %}">

                                    <div class="article_title_block">
                                        <h2>See more...</h2>
                                    </div>

                                    <div class="article_intro_block">
                                        <p>View more articles on {{subject.name}} subject</p>
                                    </div>

                                </a>
                        </div>

                    {% endif %}
                        
                {% endif %}
                
        </div>

        

    </div>

{% endblock content %}

blog/templates/blog/subject_list.html
{% extends 'base.html' %}


{% block title %}
    Subjects
{% endblock title %}



{% block content %}

<div class="subject_list_container">

        <div class="header-block">
                <h1> Subjects </h1>
        </div>

    {% if subject_list %}

        <div class="subject_list_block">

            {% for subject in subject_list %}

                <div class="subject_block">

                    <a href="{% url 'blog:subject-detail' subject.slug %}" class="subject_block_link">

                            <div class="subject_block_title">
                                    <h2>
                                            {{subject.name}}
                                    </h2>
                            </div>
                            
                            <div class="subject_block_annotation">
                                    <p>
                                        {% if subject.annotation %}
                                                {{subject.annotation}}
                                        {% else %}
                                                No description
                                        {% endif %}
                                    </p>
                                
                            </div>

                    </a>
                    
                </div>

            {% endfor %}
        
        </div>

    {% else %}
        <h4 class="not-found">
            No subjects found
        </h4>
    {% endif %}

</div>
    
    

{% endblock content %}

blog/templates/blog/tree_comment.html
<div class="comment-item comment-{{comment.pk}}">
    
    <div class="comment-item-header">

        <div class="comment-item-header-author">
            {{ comment.author }}
        </div>

        <div class="comment-item-header-date">
            {{ comment.date_of_publish|date:'Y-m-d H:i' }}
        </div>

    </div>

    <div class="comment-item-body">
        {{ comment.text }}
    </div>

    <div class="comment-reply-block">
        
        <div class="comment-item-reply-button">
                <button class="reply-button">
                    Reply
                </button>
        </div>

        <div class="comment-item-num-replies">

            <button class="show-replies-button" id="{{comment.pk}}" >
                    {% if comment.children.get_queryset|length > 0 %}
                        <span class="num-{{comment.pk}}">{{comment.children.get_queryset|length}}</span> replies
                    {% else %}
                    <span class="num-{{comment.pk}}">0</span> replies
                    {% endif %}
            </button>
        
        </div>
    
    </div>

    <div class="comment-layer-block {{comment.pk}}">
        {%if comment.children %}

            
                {% for ch in comment.children.get_queryset %}
                    {% with comment=ch template_name="blog/tree_comment.html" %}
                        {% include template_name %}
                    {% endwith %}
                {% endfor %}
            
        {% endif %}
    </div>


</div>

blog/templates/index.html
{% extends "base_generic.html" %}

{% block title %}
I overrided the title
{% endblock %}

{% block content %}
<h1>Local Library Home</h1>

  <h2>You visited site {{num_visits}} times</h2>

  <p>Welcome to <em>LocalLibrary</em>, a very basic Django website developed as a tutorial example on the Mozilla Developer Network.</p>

<h2>Dynamic content</h2>

  <p>The library has the following record counts:</p>
  <ul>
    <li><strong>Books:</strong> {{ num_books }}</li>
    <li><strong>Copies:</strong> {{ num_instances }}</li>
    <li><strong>Copies available:</strong> {{ num_instances_available }}</li>
    <li><strong>Authors:</strong> {{ num_authors }}</li>
  </ul>

{% endblock %}